''MP3 player with VMUSIC2 module, PS2 Keyboard

CON
   
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  Activate_Key = 4
  Repeat_Key   = %11101110
  Random_Key   = %11101101
  Display_Key  = %11101011
  Rew_Key      = %11100111
  Play_Key     = %11001111
  Stop_Key     = %10101111
  FF_Key       = %01101111
  InMask       = %11101111

'-- Para la pausa --------------------------------------------------------------------------------
  cntMin     = 400      ' Minimum waitcnt value to prevent lock-up
'-------------------------------------------------------------------------------------------------
  
VAR long key
    long state
    long Repeats
    long Random
    long Display

OBJ
   
  Vmusic2    : "Vmusic2"
  Men        : "Msgs"
  
PUB Start 

  outa[0..7]~
  dira[0..3]~
  dira[5..7]~
  dira[4]~~

  state := 0
  Repeats := 0
  Random := 0
  
  Men.Mstart(@Repeats)
  Vmusic2.init                                          'start VMusic2 module
  
  waitcnt(clkfreq + cnt)

  outa[Activate_Key]~

  Vmusic2.Stop

repeat  

  key := ina[7..0] & InMask

  If key == Play_Key and state == 0
     Pausa(10)
     key := ina[7..0] & InMask
     If key == Play_Key and state == 0
        If Random == 1
           Vmusic2.PlayAll_Random
        else
           If Repeats == 1
              Vmusic2.PlayAll_Repeat
           else
              Vmusic2.PlayAll
        state := 1
        Pausa(250)
        next

        
  If key == FF_Key
     Pausa(10)
     key := ina[7..0] & InMask
     If key == FF_Key
        Pausa(200)
        key := ina[7..0] & InMask
        If key == FF_Key
           repeat while (ina[7..0] & InMask) == FF_Key
              Vmusic2.FF
              state := 1
              Pausa(350)
           next
        else
           Vmusic2.SkipForward
           state := 1
           Pausa(250)
       

  If key == Rew_Key
     Pausa(10)
     key := ina[7..0] & InMask
     If key == Rew_Key
        Pausa(200)
        key := ina[7..0] & InMask
        If key == Rew_Key
           repeat while (ina[7..0] & InMask) == Rew_Key
              Vmusic2.Rew
              state := 1
              Pausa(350)
           next
        else
           Vmusic2.Previous
           state := 1
           Pausa(250)

  If key == Stop_Key
     Pausa(10)
     key := ina[7..0] & InMask
     If key == Stop_Key
        Vmusic2.Stop
        state := 0
        Pausa(250)
        

  If (key == Play_Key and state == 1) 
     Pausa(10)
     key := ina[7..0] & InMask
     If (key == Play_Key and state == 1) 
        Vmusic2.Pause
        state := 1
        Pausa(250)

  If key == Repeat_Key 
     Pausa(10)
     key := ina[7..0] & InMask
     If key == Repeat_Key 
        If state == 0
          If Repeats == 0
            Repeats := 1
            Vmusic2.Stop           ' To let show the repeat message
          else  
            Repeats := 0
            Vmusic2.Stop
          Random := 0
          state := 0
          Pausa(250)
           
  If key == Random_Key 
     Pausa(10)
     key := ina[7..0] & InMask
     If key == Random_Key 
        If state == 0
          Repeats := 0
          If Random == 0
            Random := 1
            Vmusic2.Stop           ' To let show the random message
          else  
            Random := 0
            Vmusic2.Stop
          state := 0
          Pausa(250)

  If key == Display_Key 
     Pausa(10)
     key := ina[7..0] & InMask
     If key == Display_Key 
          If Display == 0
            Display := 1
          else  
            Display := 0
          Pausa(250)

           
'        Repeat_Key  : Vmusic2.PlayAll_Repeat
'        Random_Key  : Vmusic2.PlayAll_Random
'       _playallkey  : Vmusic2.PlayAll
'       _stopkey     : Vmusic2.Stop 
'       _forwardkey  : Vmusic2.SkipForward
'       _backkey     : Vmusic2.Back
'       _previouskey : Vmusic2.Previous
'       _pausekey    : Vmusic2.Pause 
'       _playkey     : Vmusic2.play
'       _FFkey       : Vmusic2.FF
'       _REWkey      : Vmusic2.REW
'          
PUB Pausa(tiempo) | clkCycles, ms                       ' Time en milisegs
{{
   Causes a pause for the duration in mS
   Smallest value is 2 at clkfreq = 5Mhz
   Largest value is around 50 seconds at 80Mhz.
   Pause(1000)   ' 1 second pause
}}
   ms:= clkfreq / 1_000                                 ' Clock cycles for 1 ms
   clkCycles := tiempo * ms-2300 #> cntMin              ' duration * clk cycles for ms
                                                        ' - inst. time, min cntMin
   waitcnt( clkCycles + cnt )                           ' wait until clk gets there
                                